<?php

namespace Amazingcat\BraintreeVault\Block\Customer;

use Braintree\Result\Error;
use Braintree\Result\Successful;
use Magento\Braintree\Model\Adapter\BraintreeAdapterFactory;
use Magento\Framework\View\Element\Template;
use Magento\Vault\Model\CustomerTokenManagement;

/**
 * Class CreditCards
 * @package Amazingcat\BraintreeVault\Block\Customer
 */
class CreditCards extends \Magento\Vault\Block\Customer\CreditCards
{
    /**
     * @var BraintreeAdapterFactory
     */
    private $adapterFactory;

    /**
     * @param BraintreeAdapterFactory $adapterFactory
     * @param Template\Context $context
     * @param CustomerTokenManagement $customerTokenManagement
     * @param array $data
     */
    public function __construct(
        BraintreeAdapterFactory $adapterFactory,
        Template\Context $context,
        CustomerTokenManagement $customerTokenManagement,
        array $data = []
    ) {
        parent::__construct($context, $customerTokenManagement, $data);

        $this->adapterFactory = $adapterFactory;
    }

    /**
     * @return Error|Successful|null
     */
    public function getClientToken()
    {
        $token = $this->adapterFactory->create();
        return $token->generate();
    }
}
